UNIT Listrtn;

INTERFACE

USES
 	{$U MemTypes.p} MemTypes,
	{$U heapmgr.p} heapmgr,
	{$U TblDefs.p} TblDefs,
	Globals;

CONST c_maxout = 256;
			c_lead = 42;  c_lead_ppc = 30; {lead cols of info} 
			c_ldg = 33;		{cols of lead garbage}
TYPE
	char4	  = PACKED ARRAY[1..4] of CHAR;
  charary = PACKED ARRAY[0..99] of CHAR;
  pcharary = ^charary;
	Lcharary = PACKED ARRAY[0..65000] of CHAR; {Long array of Char}
	pLcharary = ^Lcharary;
  T_inst	 = ARRAY[0..5] of integer;
  pT_inst = ^T_inst;
	T_text = RECORD CASE integer OF { so we get the same I/O storage for V2 or V3}
		2:(_file:text);
		3:(IO_buf:PACKED ARRAY[1..$25A] OF CHAR);
		END;

	T_TO_info = RECORD		{ typeInfo Record info }
		TO_CharPos:Longint;	{ GT 0 to save info about field starting at this pos }
		TO_addr		:Longint;
		TO_typIw	:integer;
		TO_size		:integer;
		TO_fPos		:Longint;	{ Start of the current typeover field }
		TO_cap_buf:Pstrx;
	END;

{$Z+}
VAR  { Do NOT rearrange without consulting file "getadata.a" }
  ss	:strx;
	wst	:strx;
  out	:RECORD li:integer; line:PACKED ARRAY[1..c_maxout] of CHAR  END;
  hexstr	:PACKED ARRAY[1..c_lead] of CHAR;
  hexdig	:string[16];
  listing	:Boolean;
  quit		:Boolean;

  pc,fba_proc,comntval :Longint;  { value in comment field }
	
	dum,pass1,fileList,listfmt	:Boolean;
	
	ROMsnt_isDirty,
	Pass1Only,
	o20inst,
	Sim_flag			:Boolean;
	
	capflag,
	no_Lab_Lookup	:Boolean;	{ out_label - un structured dis-asm }
	TO_SCAN,								{ Type Over Scan Only flag - No output to buffer }
	com_cmp				:Boolean;
	
	locStkframe,
	journal,
	jlist,
	proc_rel			:Boolean;
	
	BkptFlg				:Boolean;
	Arefs,
	isOpen,
	isDbgrL				:Boolean;
	
	rd_asm				:Boolean;
	isSys7				:Boolean;
	Src_List			:Boolean;	{ Source List mode }
	ASM_wind			:Boolean;	{ TRUE if List_Pblks produced an asm window }

	hasRefs,is_MacII, NOT_MacProg,has_SANE :Boolean;	{ has_SANE = has SANE in ROM }

  ref_fmt:CHAR;
	inst_type:T_itype;
  line_lim,line_cnt:Longint;
  wi,nameindx,last_col,aci_procs:integer;

  cascade	:RECORD  cflag,mode:Boolean;  prev_val:Longint;  cinstw:integer  END;
  W_out		:RECORD  indent,MaxCol:integer  END;
  w_struct:ARRAY[0..31] of RECORD struct,variant:integer; lpc:Longint END;

	{ for Source Windows DoPcmd/SRC_WIND }
	gS_exec		:integer;		{ Text Offset of first executable }
	Hdr_len		:integer;		{ len of asm hdr 'hexstr' in listing }
	g_ldg			:integer;		{ formerly c_ldg, = Hdr_len - 9 }

{$IFC isNosy}
	usrf	:T_text; 
	listf	:T_text;
	scrf	:T_text;
{$ENDC}

	gTO_info	:T_TO_info;	{ info accumulated about type displayed on a line }
	
	code,cbp	:pT_inst;		{ ptrs into code blocks }

	LR1_SPARE		:Longint;	{  avail  }
	LR2_SPARE		:Longint;	{  avail  }
{$Z-}

PROCEDURE list_init;
PROCEDURE set_Hdr_len;
PROCEDURE init_line;
PROCEDURE put_label;
PROCEDURE comnt_line_signed(val:Longint; signedNum:Boolean);
PROCEDURE comnt_line( val:Longint );
PROCEDURE xwrit_line;
FUNCTION IsComment:Boolean;
PROCEDURE writ_line;
PROCEDURE out_line(VAR inst:T_inst);
PROCEDURE out_signed_dec( value:Longint );
{ wst Output routines}
PROCEDURE add_wst_txt(text:Pstrx; len:integer); { for MB dcmd's }
PROCEDURE dump_WLine;
PROCEDURE blank_WLine;
PROCEDURE end_wrt;
PROCEDURE wst_ToNotes; { write string in wst to Notes/ Output as a line }
PROCEDURE writ_Ln(s:strx);	{ writ_Ln - replacement for writeLn(list) }
PROCEDURE chk_Wline(nch:integer);
PROCEDURE wrt_lb( nb:integer );
PROCEDURE wrt_ln( wff:Boolean );
PROCEDURE wrt_ToColN(colNum:integer);
PROCEDURE wrt_Lstr(s:Pstrx; fw:integer);
PROCEDURE wrt_Rstr(s:Pstrx; fw:integer); { str Right justified in fw Chars}
PROCEDURE wrt_int( val:Longint; fw:integer );
PROCEDURE wrt_ThexNLZ(x:Longint);  {Trimmed Hex, no leading blanks}
PROCEDURE wrt_Thex(x:UNIV Longint);
{$IFC isNosy}
PROCEDURE MPW_V2_writeln(s:Pstrx);	{ MPW V2 writeln of a string }
PROCEDURE MPW_V2_write_PAOC(s:pcharary; txt_Len:integer);
{$ENDC}

{getadata.a}
	PROCEDURE myBeep;
	PROCEDURE set_Arrow;
	PROCEDURE Set_WatchCrsr;
  PROCEDURE wrtN_str(s:strx);
	FUNCTION D_TrpNum(tw:integer):integer;
	FUNCTION GetTrpA(rom_indx:integer):Longint;
	FUNCTION codePtr(pc:Longint):pT_inst;
  PROCEDURE NumToDStr(n:integer; s:Pstrx);
  FUNCTION  Addr_TypNam(p:strx):Pstrx;
	FUNCTION ci_CmpEQ(sa,sb:Pstrx):Boolean;
 	FUNCTION ci_CmpEQ_LenA(sa,sb:Pstrx):Boolean;
	FUNCTION  get_long(pc:UNIV hPtr):Longint;
	PROCEDURE Term_s;
	PROCEDURE cat_str(d:Pstrx; s:strx);
	PROCEDURE catP_str(d:Pstrx; s:strx);
  PROCEDURE sort4(tbl:UNIV hPtr; n:integer);
	PROCEDURE wrt_ResType(rType:UNIV char4);
	PROCEDURE suffix_name( n:integer; s:Pstrx);
	PROCEDURE BlockMove(src,dstin:UNIV hPtr; bytecnt:Longint);
  FUNCTION  get_aData(p:UNIV hPtr; size:integer):Longint;
	PROCEDURE zero_mem(p:UNIV hPtr; nbytes:Longint);
  PROCEDURE strCopy( d:Pstrx; s:strx; indx,count:integer );
	PROCEDURE copyStr(d:Pstrx; s:strx);
	PROCEDURE CopyToS(VAR ts:strx);
  PROCEDURE out_hex(h:Longint);
  PROCEDURE addchar(c:CHAR);
  PROCEDURE addstr(s:strx);
  PROCEDURE out_dig(i:integer);
  PROCEDURE tab(i:integer);
  PROCEDURE clr_line;
  PROCEDURE put_pc( x:Longint );
  PROCEDURE list_hex( VAR inst:T_inst; nwds:integer );
  PROCEDURE upperCase( s:Pstrx );
  PROCEDURE wrt_str( s : strx );
	PROCEDURE wrt_chr( ch:CHAR );
	PROCEDURE wrt_hex(x:Longint; ndig:integer);
  PROCEDURE addtext(fba:UNIV hPtr; bytes:integer);
  PROCEDURE add_Line(VAR s:strx); {adds a string & a EOL -cannot be a lit }
  PROCEDURE add_str_CB(s:strx); 
	PROCEDURE add_EOL;
	PROCEDURE addSstr(s:strx; indx,count:integer);
	PROCEDURE add_comma;
	PROCEDURE opc_line(opc:strx);
	PROCEDURE pseudo_line(opc:strx; val:Longint);

IMPLEMENTATION {$D-} {$R-}

CONST  c_MaxCol = 78;

	PROCEDURE SelToNotes(p:Ptr; len:Longint); EXTERNAL; {write chars to -Notes-}
	PROCEDURE wrtN_ln(s:strx); EXTERNAL;
	PROCEDURE fixNotes; EXTERNAL;
{getadata.a}
	PROCEDURE myBeep; EXTERNAL;
	PROCEDURE set_Arrow; EXTERNAL;
	PROCEDURE Set_WatchCrsr; EXTERNAL;
  PROCEDURE wrtN_str(s:strx); EXTERNAL;
	FUNCTION D_TrpNum(tw:integer):integer; EXTERNAL;
	FUNCTION GetTrpA(rom_indx:integer):Longint; EXTERNAL;
	FUNCTION codePtr(pc:Longint):pT_inst; EXTERNAL;
  PROCEDURE NumToDStr(n:integer; s:Pstrx); EXTERNAL;
  FUNCTION Addr_TypNam(p:strx):Pstrx; EXTERNAL;
	FUNCTION ci_CmpEQ(sa,sb:Pstrx):Boolean; EXTERNAL;
	FUNCTION ci_CmpEQ_LenA(sa,sb:Pstrx):Boolean; EXTERNAL;
  FUNCTION get_long(pc:UNIV hPtr):Longint; EXTERNAL;
	PROCEDURE Term_s; EXTERNAL;
	PROCEDURE cat_str(d:Pstrx; s:strx);EXTERNAL;
	PROCEDURE catP_str(d:Pstrx; s:strx);external;
  PROCEDURE sort4(tbl:UNIV hPtr; n:integer); EXTERNAL;
	PROCEDURE wrt_ResType(rType:UNIV char4); EXTERNAL;
	PROCEDURE suffix_name( n:integer; s:Pstrx); EXTERNAL;
	PROCEDURE BlockMove(src,dstin:UNIV hPtr; bytecnt:Longint); EXTERNAL;
  FUNCTION  get_aData(p:UNIV hPtr; size:integer):Longint; EXTERNAL;
	PROCEDURE zero_mem(p:UNIV hPtr; nbytes:Longint); EXTERNAL;
  PROCEDURE strCopy( d:Pstrx; s:strx; indx,count:integer );EXTERNAL;
	PROCEDURE copyStr(d:Pstrx; s:strx);EXTERNAL;
	PROCEDURE CopyToS(VAR ts:strx); EXTERNAL;
  PROCEDURE out_hex(h:Longint); EXTERNAL;
  PROCEDURE addchar(c:CHAR); EXTERNAL;
  PROCEDURE addstr(s:strx);EXTERNAL;
  PROCEDURE out_dig(i:integer); EXTERNAL;
  PROCEDURE tab(i:integer); EXTERNAL;
  PROCEDURE clr_line; EXTERNAL;
  PROCEDURE put_pc( x:Longint); EXTERNAL;
  PROCEDURE list_hex( VAR inst:T_inst; nwds:integer ); EXTERNAL;
  PROCEDURE upperCase( s:Pstrx); EXTERNAL;
  PROCEDURE wrt_str(s : strx); EXTERNAL;
	PROCEDURE wrt_chr(ch:CHAR); EXTERNAL;
	PROCEDURE wrt_hex(x:Longint; ndig:integer); EXTERNAL;
  PROCEDURE addtext(fba:UNIV hPtr; bytes:integer); EXTERNAL;
  PROCEDURE add_Line(VAR s:strx); EXTERNAL; {adds a string & a EOL -cannot be a lit }
  PROCEDURE add_str_CB(s:strx); EXTERNAL; 
	PROCEDURE add_EOL; EXTERNAL;
	PROCEDURE addSstr(s:strx; indx,count:integer); EXTERNAL;
	PROCEDURE add_comma; EXTERNAL;
	PROCEDURE opc_line(opc:strx); EXTERNAL;
	PROCEDURE pseudo_line(opc:strx; val:Longint); EXTERNAL;
{disasm.p}
  PROCEDURE set_cascade( VAR val:Longint; VAR iword:integer );EXTERNAL;
  PROCEDURE chk_label; EXTERNAL;
  PROCEDURE list_alt_names; EXTERNAL;
{getfile.p}
  PROCEDURE rd_com_ln; EXTERNAL;
{valtosym.p}
  FUNCTION  find_struct(ss:strx):integer; EXTERNAL;

{$S init0 }
PROCEDURE list_init;
begin
  hexdig := '0123456789ABCDEF';  wst := '';
	line_cnt := 0;  line_lim := $7FFE;		{ until we fix SetCtlMax, Min & Value }
  with W_out do begin MaxCol := c_MaxCol;  indent := 0  end
end;

{$S }

PROCEDURE set_Hdr_len;
begin
	Hdr_len := c_lead;
	if g_ppc_asm then Hdr_len := c_lead_ppc;
	g_ldg := Hdr_len - 9;
end;

{$IFC isNosy}
PROCEDURE write_cl(s:Pstrx; lbc:integer);	{ Nosy - write to Hardcopy file }
begin
	if lbc > 0 then write(listf._file,' ':lbc);  writeln(listf._file,s^)
end;

PROCEDURE MPW_V2_writeln(s:Pstrx);	{ MPW V2 writeln of a string }
begin
	writeln(s^);
	if fileList then write_cl( s, 0 )
end;

PROCEDURE MPW_V2_write_PAOC(s:pcharary; txt_Len:integer);
begin
	write(s^:txt_Len);
	if fileList then write(listf._file,s^:txt_Len);
end;
{$ENDC}

PROCEDURE init_line;
begin
	clr_line;
	if proc_rel then put_pc(pc-SRA(fba_proc)) else put_pc(pc)
end;

PROCEDURE put_label;
VAR i,k:integer;  ts:strx;
begin
	set_Hdr_len;
  k := Length(ss);
{$IFC isNosy}					{ Nosy - HardCopy option }
  if k > 0 then
    if k <= 8 then begin
      for i := 1 to k do hexstr[i+g_ldg] := ss[i];  hexstr[g_ldg] := ' '
		end
		else begin
      writeln(' ':g_ldg,ss);
			line_cnt := line_cnt + 1;
      if fileList then begin
        if listfmt then i := g_ldg else i := 0;  write_cl( @ss , i )
			end;
    end;
{$ELSEC}	{ isDbgr  }
  if k > 0 then
    if k <= 8 then begin
      for i := 1 to k do hexstr[i+g_ldg] := ss[i];  hexstr[g_ldg] := ' '
		end
		else begin
      		 {'123456789-123456789-123456789-123'  }
			ts := '                                 ';
			ts[0] := Chr(g_ldg);
			add_str_CB(ts);  add_Line(ss);   {  writeln(' ':g_ldg , ss); }
    end;
{$ENDC}
end;

PROCEDURE comnt_line_signed(val:Longint; signedNum:Boolean);
VAR i:integer;  minus:Boolean;
begin
  if listfmt then begin
    set_Hdr_len;
    i := g_ldg;
		minus := FALSE;
		if signedNum then begin
			minus := (val < 0);  val := ABS(val);
		end;
    REPEAT
			i := i - 1;  hexstr[i] := hexdig[BAND(val,15)+1];  val := BSR(val,4);
    UNTIL val = 0;
		if minus then hexstr[i-1] := '-';
  end
end;

PROCEDURE comnt_line(val:Longint);
begin
	comnt_line_signed(val,TRUE);
end;

PROCEDURE process_kbi;external;

{$IFC isNosy}
PROCEDURE xwrit_line;
VAR i,j:integer;  os:strx;
LABEL 1;
begin
	set_Hdr_len;
  if rd_asm then begin	{ Nosy - Review Data in window mode }
    FOR j := g_ldg+1 TO Hdr_len DO os[j-g_ldg] := hexstr[j];
		os[0] := Chr(9);
    writeln(os,out.line:out.li-1);  exit(xwrit_line)
  end;
  writeln(hexstr:Hdr_len , out.line:out.li-1);
  if capflag then GOTO 1;

  if fileList then begin	{ Nosy - HardCopy option }
    if listfmt then begin
			i := Hdr_len-2;  for j := 3 to Hdr_len do os[j-2] := hexstr[j]
		end
    else begin
			i := 9;  for j := g_ldg+1 to Hdr_len do os[j-g_ldg] := hexstr[j]
		end;
    for j := 1 to out.li-1 do os[i+j] := out.line[j];
    i := i + out.li - 1;  os[0] := Chr(i);
    write_cl( @os, 0 )
  end;
1:line_cnt := line_cnt + 1;
  if line_cnt >= line_lim then 
		if NOT quit then process_kbi;
end;

{$ELSEC} { is dbgr }

PROCEDURE xwrit_line;
begin
	set_Hdr_len;
  if capflag then begin
		addtext(@hexstr,Hdr_len);  addtext(@out.line,out.li-1);  add_EOL;
	end
(*--
	else begin { this case should never happen }
		out.line[out.li] := EoLine;
		SelToNotes(@hexstr,Hdr_len);  SelToNotes(@out.line,out.li);
	end;
--*)
end;
{$ENDC}

{$S list_data}
PROCEDURE append_com;
LABEL 1;

  PROCEDURE add_com;
  VAR i:integer;
  begin
    if not com_cmp then begin
      tab(21);  addchar(';');
      for i := cf_col to Length(cf_cl) do
        begin out.line[out.li] := cf_cl[i];  out.li := out.li+1  end;
    end;
    xwrit_line
  end;

  PROCEDURE slash_com( callow:Boolean );
  LABEL 2,3;
  VAR i,j,k,regn,stindx,uVAR:integer;  strname:strx;  withflag:Boolean; c:CHAR;

    PROCEDURE next_ch;
    begin  REPEAT  i := i + 1;  c := cf_cl[i]  UNTIL c <> ' '  end;

  begin
    if cf_cl[cf_col+1] <> '/' then exit(slash_com);
    upperCase(@cf_cl);  cf_cl[Length(cf_cl)+1] := '/';  i := cf_col + 1;  next_ch;
    REPEAT i := i + 1 UNTIL (cf_cl[i] = ' ') | (cf_cl[i] = '/'); {skip rest of keyword}
    if c = 'L' then exit(slash_com); {processed by DI_proc}
    if c = 'C' then begin
      if not callow then begin  wrt_str('/C must be appended');  dump_WLine  end
      else with cascade do begin
        if cflag then cflag := FALSE
        else begin
          set_cascade(prev_val,cinstw);  next_ch;
          if c <> '/' then begin
            mode := (c = 'D');
            if not ((c = 'A') | mode) then begin
              wrt_str('/C command - mode must be Ascii or Decimal');  dump_WLine;
							GOTO 3
						end;
          end;
          cflag := TRUE;
        end
      end;
      GOTO 3
    end;
    withflag := (c = 'W');  if cf_cl[i] = '/' then GOTO 2;
    next_ch;  if c = '/' then GOTO 2;
    j := i;  k := 0;  uVAR := 0;
    REPEAT k := k + 1;  strname[k] := cf_cl[j];  j := j + 1  UNTIL cf_cl[j] in ['=','/',':'];
    while (k > 0) & (strname[k] <= ' ') do k := k - 1; { elim trailing blanks }
		strname[0] := Chr(k);  stindx := find_struct(strname);
    if withflag then begin
      if cf_cl[j] = ':' then begin
				uVAR := ORD(cf_cl[j+1]) - ORD('0');  j := j + 2;
				if (uVAR < 0) OR (uVAR > 9) then GOTO 2;
				{chk uVAR to see if valid}
				c := cf_cl[j];  if not ((c = '/') OR (c = '=')) then GOTO 2
			end;
			if cf_cl[j] = '=' then begin
				if cf_cl[j+1] <> 'A' then GOTO 2;
				regn := ORD(cf_cl[j+2]) - ORD('0'); if (regn < 0) OR (regn > 6) then GOTO 2
			end
			else with out do begin {search inst for ',An'}
				if NOT ((line[last_col-3] = ',') & (line[last_col-2] = 'A')) then begin
					wrt_str(' could not find destin A-reg');  dump_WLine;  GOTO 3
				end;
				regn := ORD(line[last_col-1]) - ORD('0');
			end;
			with w_struct[regn] do begin  struct := stindx; variant := uVAR; lpc:= $7fFFFF end
		end
		else begin {/endwith}
			for i := 0 to 6 do with w_struct[i] do if struct = stindx then struct := 0
		end;
		GOTO 3;
	2:wrt_str('format error in With/EndWith comment line');  dump_WLine;
	3:
	end;

	PROCEDURE insrtComLine;
	VAR i:integer;
	begin
		if not com_cmp then with out do begin
			li := 1;
			for i := cf_col+1 to Length(cf_cl) do begin line[li] := cf_cl[i];  li := li+1  end;
			line[li] := ' ';  li := li+1; {bug in I/O}
			clr_line;  hexstr[34] := ';';
			xwrit_line;
		end;
	end;

begin {append_com}
	if cf_sep = 'i' then begin
		xwrit_line; {write current line}
	1:while cf_addr = pc do begin
			insrtComLine;  slash_com(FALSE);
			rd_com_ln;
			if cf_sep <> 'i' then LEAVE;
		end;
		exit(append_com)
	end
	else if cf_sep = ' ' then begin  {space out to col 30 and append comment line}
		add_com;  slash_com(TRUE);  rd_com_ln;
		if cf_sep = 'i' then GOTO 1;
		exit(append_com)
	end
	else if cf_sep = '/' then begin { old style slash comments }
		add_com;  wrt_str('error - old style /comment');  dump_WLine;  rd_com_ln
	end
end;

{$S }
FUNCTION IsComment:Boolean;
begin
	IsComment := (com_chk & (cf_addr = pc));
end;

PROCEDURE writ_line;
begin
	if IsComment then append_com else xwrit_line;
end;

PROCEDURE out_line(VAR inst:T_inst);
TYPE
	T_wc = RECORD CASE integer OF
					0:(w:integer); 1:(c:packed array[1..2] of CHAR)
				 END;
VAR i,j,k:integer;   ch:CHAR;  c:T_wc;
begin
	init_line;
	last_col := out.li;
	if o20inst then hexstr[9] := '$';  o20inst := FALSE;
	if inst_type = i_xx then hexstr[9] := '';
	if BkptFlg then begin hexstr[10] := '';  BkptFlg := FALSE  end;

	if NOT isDbgrL then begin { fill in Hex Ascii in cols 10 - 33 }
		if g_ppc_asm then begin
			if comntval <> 0 then begin
				comnt_line_signed(comntval,FALSE);  hexstr[12] := '>';
			end
			else list_hex( inst, 2 );
		end
		else begin	{ 68K & PPC/PEF in Nosy }
			list_hex( inst, min(wi,3) );
			if comntval <> 0 then
				comnt_line_signed(comntval, NOT romflag)
			else if NOT isPef then begin { list Ascii }
				hexstr[26] := '''';  k := 27;
				for i := 0 to min(wi-1,2) do begin
					c.w := inst[i];
					for j := 1 to 2 do begin
						ch := c.c[j];
						if (ch < ' ') or (ch > maxascii) then ch := '.';
						hexstr[k] := ch;  k := k + 1
					end
				end;
				hexstr[k] := '''';
			end
		end;
	end;
	if NOT no_Lab_Lookup then begin
		chk_label;  put_label;
	end;
	if nameindx > 0 then list_alt_names;
	writ_line
end;


PROCEDURE out_signed_dec( value : Longint );
VAR  cc : PACKED ARRAY[1..14] OF CHAR; i:integer;  n,k:Longint;
begin
  if value = 0 then begin  addchar( '0' );  exit(out_signed_dec)  end;
  n := value;
  if n < 0 then begin n := -n;  addchar( '-' )  end;
  if n = $80000000 then begin addstr( '$80000000' ); exit(out_signed_dec)  end;
  i := 14;
  while n > 0 do begin
    k := n DIV 10;   cc[i] := hexdig[n - k*10+1];
    n := k;  i := i - 1
  end;
  REPEAT
    i := i + 1;  out.line[out.li] := cc[i];  out.li := out.li + 1
  UNTIL i = 14;
end;

{$S }
PROCEDURE wrt_ToColN(colNum:integer);
VAR j:integer;
begin
  j := Length(wst);
	while j < colNum do begin  j := j + 1;  wst[j] := ' '  end;
  wst[0] := Chr(j)
end;

PROCEDURE wrt_Lstr(s:Pstrx; fw:integer);
VAR i,j:integer;
begin
  j := Length(wst);  wrt_str(s^);
  if Length(s^) < fw then  begin
     j := Length(wst);
     for i := Length(s^)+1 to fw do begin  j := j + 1;  wst[j] := ' '  end;
   end
   else begin
     j := j + fw;  wst[j] := ' '  {ensure a trailing blank}
   end;
   wst[0] := Chr(j)
end;

PROCEDURE wrt_Rstr(s:Pstrx; fw:integer); { str Right justified in fw Chars}
VAR i,j:integer;
begin
	j := Length(wst);
	for i := 1 to fw-Length(s^) do begin  j := j + 1;  wst[j] := ' '  end;
	wst[0] := Chr(j);
	wrt_str(s^);
end;

PROCEDURE wrt_ln( wff:Boolean );
begin
{$IFC isNosy}
  writeln(wst);
  if fileList & NOT capflag & wff then write_cl( @wst, 0 );
{$ELSEC}  { isDbgr }
  if TO_SCAN then with gTO_info do begin
		if TO_CharPos = 0 then begin
			if TO_cap_buf <> NIL then begin
				copyStr(TO_cap_buf,wst);	{ capture the line }
				TO_cap_buf := NIL;
			end;
		end;
		bufrec.indx := bufrec.indx + Length(wst) + 1;	{ accumulate buffer Length }
	end
	else
		if capflag then add_Line(wst) else wrtN_ln(wst);
{$ENDC}
  wst := ''
end;

PROCEDURE add_wst_txt(text:Pstrx; len:integer); { for MB dcmd's }
VAR i,len_wst:integer;
BEGIN
	len_wst := Length(wst);
	for i := 1 to len do wst[i+len_wst] := text^[i-1];
	wst[0] := Chr(len_wst + len);
END;


PROCEDURE dump_WLine;
VAR i:integer;
begin
  with W_out do if Length(wst) > indent then begin
		wrt_ln(FALSE);
		for i := 1 to indent do wst[i] := ' ';	wst[0] := Chr(indent);
	end
end;

PROCEDURE blank_WLine;
begin
	wst := ' ';  dump_WLine
end;

PROCEDURE end_wrt;
begin
	wst := '';    with W_out do begin MaxCol := c_MaxCol;  indent := 0  end
end;

PROCEDURE wst_ToNotes; { write string in wst to Notes/ Output as a line }
begin
{$IFC isNosy}
	if NOT inEdit then writeln(wst) else
{$ENDC}
	begin  wrtN_ln(wst);  fixNotes  end;
  wst := '';
end;

PROCEDURE writ_Ln(s:strx);	{ writ_Ln - replacement for writeLn(list) }
begin
 copyStr(@wst,s);  wst_ToNotes
end;

PROCEDURE chk_Wline(nch:integer);
begin  if Length(wst) + nch > W_out.MaxCol then dump_WLine  end;

PROCEDURE wrt_lb( nb:integer );
VAR i:integer;
begin
  if listfmt then begin
		set_Hdr_len;	nb := nb + g_ldg;
	end;
  for i := 1 to nb do wst[i] := ' ';
	wst[0] := Chr(nb)
end;

PROCEDURE wrt_int( val:Longint; fw:integer );
VAR cc,os:strx; i,j:integer;  n,k:Longint;  mi:Boolean;
LABEL 1;
begin
  cc := '';
  if val = 0 then begin  cc :='0';  i := 1;  GOTO 1  end;
  n := val;  mi := (n < 0);
  if mi then n := -n;
  i := 0;
  while n > 0 do begin
    k := n DIV 10;  i := i + 1;   cc[i] := hexdig[n - k*10+1];  n := k;
  end;
  if mi then begin i := i + 1;  cc[i] := '-'  end;
1:os := '            ';
  if fw < 0 then fw := i - fw - 1; {number of leading blanks - 1}
  for j := 1 to i do os[fw+1-j] := cc[j];  os[0] := Chr(fw);
  wrt_str(os)
end;

(*
PROCEDURE wrt_hex(x:Longint; ndig:integer);
VAR i,fw,nd:integer;  s:strx;
begin
  fw := abs(ndig);  nd := 8; if fw < 8 then nd := fw;
  s := '           ';  s[0] := Chr(fw);
  for i := fw downto fw+1-nd do begin
    s[i] := hexdig[BAND(x,15)+1];  x := BSR(x,4);
    if (x = 0) and (ndig < 0) then LEAVE
  end;
  wrt_str(s)
end;
*)

PROCEDURE wrt_ThexNLZ(x:Longint);  {Trimmed Hex, no leading blanks}
VAR last_dig,i:integer;  s:string[9];  ps:Pstrx;
begin
  s := '       ';  i := 8;
	REPEAT
    last_dig := BAND(x,15);
		s[i] := hexdig[last_dig+1];  x := BSR(x,4);  i := i - 1
  UNTIL (x = 0) or (i = 0);
	ps := pointer(ORD(@s)+i);  ps^[0] := Chr(8-i);
  wrt_str(ps^)
end;

{ wrt_Thex - Trimmed Hex, no leading blanks, lead zero if 1st is Alpha}
PROCEDURE wrt_Thex(x:UNIV Longint);
VAR last_dig,i:integer;  s:string[9];  ps:Pstrx;
begin
  s := '       ';  i := 8;
	REPEAT
    last_dig := BAND(x,15);
		s[i] := hexdig[last_dig+1];  x := BSR(x,4);  i := i - 1
  UNTIL (x = 0) or (i = 0);
	if (last_dig > 9) & (i > 0) then begin
		s[i] := '0';  i := i - 1;
	end;
	ps := pointer(ORD(@s)+i);  ps^[0] := Chr(8-i);
  wrt_str(ps^)
end;

end. {listrtn}
