UNIT Val_dbg;  {Symbolic Debugger -  Steve Jasik 1986 - 1993}

INTERFACE

USES 
	MemTypes, heapmgr, TblDefs, Listrtn,
	Files, GetFile, GetCodeI,
	ValToSym,
	MixedMode, MachineExceptions, Globals;

CONST
	c_Rw_wide68 = 40;  c_Regs_wwidePPC = 54; { window Width of -Registers- }
	c_Regs_whigh = $010B; { stack, 11 lines }
	opt_space = Chr($CA);	{ option-space - marks begin of a modifiable field }

	c_TrMaxParams = 12; c_LastOddType = 6;

TYPE
	T_typIndx = integer;
	T_paramInfo = RECORD
		offset :integer;		{ - for stack offset, >= 0 for D0-D7, A0-A7 }
		typIndx:T_typIndx;	{ "tbli" to a type table }
		name   :string[15]; { varNameString }
	END;
	pT_paramInfo = ^T_paramInfo;

	T_auxI = RECORD
		nParams:integer;
		stkSize:integer; {only need 8 bits here, max 10 params * 4 }
		funType:integer; {typIndx}
		funSize:integer; {regnum or NEG of size on stk}
		case integer of
		0:(isVar,isFunc,SaveEnt:Boolean);
		1:(flags:Longint)
	END;

	T_REG = RECORD
		Dreg	:ARRAY[0..7] OF Longint;
		Areg	:ARRAY[0..4] OF Longint;
		REG_A5,REG_A6,REG_A7 :Longint
	END;
	pT_REG = ^T_REG;
	T_GPR_Regs = ARRAY[0..31] OF Integer64;

	T_eletype = (e_unknown,e_int,e_chr,e_decl);
	T_RegSize = (rs_All,rs_Upper,rs_Lower);

	T_SOM_inf = RECORD SOM_Off,SOM_Len:integer; {18,14}  SOM_cName:Pstrx;  END;
	T_SOM_REC = RECORD
		Obj_addr	:Longint;
		n_som			:Longint;
		SOM_Info	:ARRAY[1..64] OF T_SOM_inf;
	END;

{$Z+}
VAR
	SG	:hPtr; {^T_SysCom;{Ptr to USER's System Global Area (may be at 0)}
	{ REGS, USR_PC, USR_SR order set for Macsbug dcmd's }
	USR_SR:integer; 	{ User Status Reg }
	USR_PC:Longint; 	{ User PC }
	REGS	:T_REG;	  	{ REG SAVE AREA }

	PPC_GPR :T_GPR_Regs;	{ working copy of GPR's }

	PPC_EI	:pExceptionInfo;	{ addr of the Exception info PPC }

	RegInfo :PACKED RECORD
						RegSize:T_RegSize;  isPPC:Boolean;  RegNum:integer;
					END;

	TcAuxi		:T_auxI;
	TrpBuf		:ARRAY[1..c_TrMaxParams] OF T_paramInfo;
	gCaseVal	:integer; 	{ global Case Val }
	g_Frame		:Longint;		{ A6 addr of current Proc }
	LBA_ROM		:Longint;
	BadZeroVal:Longint;		{ nasty value stored in Loc 0 and disposed blocks, etc }
	gRec_typIw:integer;		{ typIw of Lst_RecVal }
	g_alt_doc	:integer;		{ alternate Doc indicator for Types }

	vd1_SPARE	:Longint;	{  avail  }
	vd2_SPARE	:Longint;	{  avail  }
{$Z-}

FUNCTION typ2str(sg_Ptr:Longint; USR_PC:Longint; VAR REGS:T_REG):Boolean;
FUNCTION isRAMaddr(addr:Longint):Boolean;
function Data_at(addr:UNIV hPtr; size:integer):Longint;
PROCEDURE GetBounds(typIw:integer; VAR ll,ul:integer; VAR eletype:T_eletype); {of Array/SET}
PROCEDURE wrt_RefNum(RefNum:integer);
PROCEDURE Record_AT(typIw:integer; addr:Longint);
PROCEDURE LstBasVal(VAR size:integer; basetyp:integer; addr:Longint );
PROCEDURE ValueOf(VAR size:integer; typIw:integer; addr:Longint; fOnePer:Boolean );
function  PsizeOf( typIw:integer ):integer;
PROCEDURE TrapListInfo(VAR s:strx; VAR TypErr:integer);
PROCEDURE Get_TrapInfo(trpNum:integer; VAR s:strx);

IMPLEMENTATION {$D-} {$R-}

{$S disasm}

TYPE
	DateTimeRec = RECORD Year,Month,Day,Hour,Minute,Second,DayOfWeek:integer END;
	BytePtr = ^Byte;

(* -- moved to ValToSym
	base_sym = (b_qmark,b_bool,b_Byte,b_sgnbyte,b_ASCII,b_strx,b_Cstr,b_ptr,b_pptr,b_hdl
							,b_int,b_Word,b_long,b_HLong,b_DateTime,b_Char,b_OSErr,b_SCSIErr
							,b_RefNum,b_VRefNum,b_ProcOff,b_Real,b_Dbl,b_Extended,b_TrapWord
							,b_Qstr,b_Extend10,b_Fixed,b_JT_Off,b_ClassID,b_TObject
							,b_CppKludge,b_hdl_Ary
							,b_ProcOf,b_strN);	{ b_ProcOf used in SADE.p }
--*)
VAR OnePer,gOnePer:Boolean;  gRecAddr:Longint;
		g_inArry	:Boolean;

{$IFC NOT isNosy}
	PROCEDURE sort(tbl:UNIV hPtr; n:integer); EXTERNAL;
	FUNCTION DO_SOM_info(VAR SOM_REC:T_SOM_REC):Boolean;	EXTERNAL;
	FUNCTION get_SOM_Type(ptypName:Pstrx; VAR alt_doc,typIw:integer):Boolean;	EXTERNAL;
	FUNCTION Val_LocVar(Faddr:Longint; LV_typIw:integer):Longint; EXTERNAL;
	PROCEDURE wrt_nameP; EXTERNAL;	{ wrt_str( " name+offset" ) of addr in bn_off }
	FUNCTION  ValidHdl(addr:Longint; VAR Raddr:UNIV hPtr):Boolean; EXTERNAL;
{obj_disp.p}
	FUNCTION is_Ptr_MacApp:Boolean;  EXTERNAL;
	FUNCTION ClassID_Of(obj_Hdl:UNIV Handle):Longint;  EXTERNAL;
	PROCEDURE GetClassNameFromID(classID:integer; VAR clName:strx); EXTERNAL;
	PROCEDURE wrt_class_At(obj_Hdl:Longint); EXTERNAL;
{tasks.p}
	FUNCTION isMasterPtr_addr(mpAddr:Longint):Boolean; EXTERNAL;
	PROCEDURE UseDoc(i:integer); EXTERNAL;
	PROCEDURE ListTask(tskNum:integer); EXTERNAL;
	function  pPtrtoPrel(addr:Longint):Boolean; EXTERNAL;
{getadata.a}
	PROCEDURE wrt_fpS(fpr:Extended); EXTERNAL;
	PROCEDURE wrt_fpD(fpr:Extended); EXTERNAL;
	PROCEDURE wrt_fpr(fpr:Extended); EXTERNAL;
	PROCEDURE wrt_fpr10(fpr:Extended); EXTERNAL;
	PROCEDURE wrt_Fixed(fpr:Longint); EXTERNAL;
	FUNCTION get_fName(name:Pstrx; RefNum:integer):Boolean; EXTERNAL;
{$ENDC}
{getadata.a}
	FUNCTION isValid_Addr(addr:UNIV Longint):Boolean; EXTERNAL;
{Dbgr.a}
	FUNCTION Valid_Addr(addr:UNIV Longint):Boolean; EXTERNAL;
{disasm.p}
	function  find_proc(ival:Longint):integer; EXTERNAL;
{Util.p}
	function	fnd_blknum(ival:Longint):integer; EXTERNAL;
	PROCEDURE get_name(ip:integer); EXTERNAL;

{System Libs}
	PROCEDURE Secs2Date(s:Longint; VAR d:DateTimeRec); INLINE
		$205F,  { POP.L   A0 }
		$201F,  { POP.L   D0 }
		$A9C6;  { _Secs2Date }


{$S }			{ A UserP for Jasik }
FUNCTION typ2str(sg_Ptr:Longint; USR_PC:Longint; VAR REGS:T_REG):Boolean;
begin
	typToStr(REGS.Dreg[0],cf_cl);
	typ2str := TRUE;
end;

{$S disasm}

FUNCTION isRAMaddr(addr:Longint):Boolean;
begin
	IF is_32Bit then isRAMaddr := LT32(addr , sav_MemTop)
	else begin
		addr := Clean_Addr(addr);
		isRAMaddr := ((addr < MD_ROMBase) OR (addr >= LBA_ROM))
	end;
end;

PROCEDURE Val_Of(VAR size:integer; typIw:integer; addr:Longint ); FORWARD;

PROCEDURE	Mark_Field_NO_Modify;	{ replace opt-space with a normal space }
begin
	if wst[Length(wst)] = opt_space then wst[Length(wst)] := ' ';
end;

PROCEDURE wrt_subrng(i,typIw:integer; eletype:T_eletype);
VAR ts:strx;  {write value of subrange field with NO leading blanks}
begin
	case eletype of
		e_int:wrt_int(i,-1);
		e_chr:if (i < ORD(' ')) or (i > $AA) then begin wrt_chr('$');  wrt_hex(i,2)  end
						else begin wrt_chr('''');  wrt_chr(Chr(i));  wrt_chr('''')  end;
	 e_decl:begin
						get_decl_val(typIw,i,ts);
						if Length(ts) = 0 then wrt_int(i,-1) else wrt_str(ts)
					end
	end
end;

FUNCTION Data_at(addr:UNIV hPtr; size:integer):Longint;
begin
{$IFC NOT isNosy}
	if LT32(ORD(addr),MD_L_SysCom) then addr := pointer(ORD(addr) + ORD(SG));
{$ENDC}
	Data_at := get_aData(addr,size)
end;

Type T_erCode = (ec_OddAddr,ec_OddHdl,ec_BadPtr,ec_QType,ec_QABType,ec_OddWAA,ec_NotYet);

PROCEDURE ErrMsg(erCode:T_erCode);
begin
	wrt_chr('<');
	case erCode of
	ec_OddAddr  :wrt_str('address ODD');
	ec_OddHdl   :wrt_str('Handle ODD');
	ec_BadPtr   :wrt_str('Bad Pointer');
	ec_QType    :wrt_str('Unknown Type');
	ec_QABType  :wrt_str('Unknown Bounds or SET Type');
	ec_OddWAA   :wrt_str('Word aligned array begins on ODD addr');
	ec_NotYet   :wrt_str('Not Yet');
	end;
	wrt_chr('>')
end;

PROCEDURE GetBounds(typIw:integer; VAR ll,ul:integer; VAR eletype:T_eletype); {of Array/SET}
VAR pbt:pT_Typent;  maxUL:integer;  LABEL 1;
begin
	eletype := e_int; {default}
	if sym_typOF(typIw) = EQU_ then begin { EQU_,n = subrg 0..n }
		ll := 0;  ul := BAND(typIw,c_MtypIndx);  exit(GetBounds)
	end;
	pbt := TypEnt(typIw);
	case Ttbl of
	 base:begin {Char or Byte}
					ll := 0;  ul := 255;
					if base_sym(typIw) = b_Char then eletype := e_chr
					else if base_sym(typIw) <> b_Byte then GOTO 1
				end;
	 decl:begin
					eletype := e_decl;  ll := 0;  ul := BAND(pbt^.val,M_decl_UL);
				end;
 subrng:begin
					with pbt^ do begin ll := lb;  ul := ub;  typIw := srtype  end;
					if BTST(typIw,c_IsVarUB) then begin
						typIw := BAND(typIw,m_NOTIsVarUB);
{$IFC NOT isNosy}
						if BTST(ul,c_ValOF) then begin { value of Local Var in curProc }
							ul := Val_LocVar(g_Frame,ul);
						end
						else begin
							if gRecAddr = 0 then ul := 0
							else ul := BAND($7FFF,pinteger(gRecAddr+ul)^);
						end;
{$ELSEC}
						if gRecAddr = 0 then ul := 0
						else ul := BAND($7FFF,pinteger(gRecAddr+ul)^);
{$ENDC}
						maxUL := 8191;
						if gRec_typIw = RD_typIw then maxUL := 100;
						if ul > maxUL then ul := maxUL;	{ avoid infinite loops }
					end;
					if sym_typOF(typIw) = decl then eletype := e_decl
					else if typIw =  ORD(b_Char) then eletype := e_chr
				end;
			otherwise GOTO 1
	 end;
	exit(GetBounds);
1:eletype := e_unknown;  ErrMsg(ec_QABType)
end;

PROCEDURE cond_wrt_opt_space;
begin
	if (wst[Length(wst)] = ':') OR g_inArry then wrt_chr(opt_space)
	else if wst[Length(wst)] <> opt_space then wrt_chr(' ');
end;

FUNCTION ZroPtr(pval:Longint):Boolean;
begin
	ZroPtr := TRUE;
	if pval = 0 then begin
		cond_wrt_opt_space;  wrt_str('NIL');
	end
	else if pval = BadZeroVal then begin
		cond_wrt_opt_space;  wrt_str('NIL - Not_Init')
	end
	else if pval = -1 then begin
		cond_wrt_opt_space;  wrt_str('Not_Init')
	end
	else ZroPtr := FALSE;
end;

PROCEDURE Lst_Ptr(pval:Longint);
VAR i:integer;
begin
	if ZroPtr(pval) then exit(Lst_Ptr);
	i := 6;
	if is_MacII then begin if BSR(pval,24) <> 0 then i := 8 end
	else if BSR(pval,24) <> 0 then begin wrt_hex(BSR(pval,24),2);  wrt_chr(' ') end;
	wrt_str('@');  wrt_Thex(pval) 
end;

PROCEDURE wrt_Bad_Ptr(addr:Longint);
begin
	cond_wrt_opt_space;
	Lst_Ptr(addr);  wrt_str(' <-BadPtr');  
end;

function VD_ValidPtr(VAR addr:Longint):Boolean;
VAR tb:Boolean;
begin
	tb := isValid_Addr(addr) & NOT Odd(addr);
	VD_ValidPtr := tb;
	if tb then addr := Data_at(addr,4)
				else wrt_Bad_Ptr(addr)
end;

PROCEDURE List_Proc_Ptr(addr:Longint);
VAR is_UPP:Boolean;  sav_doc:integer;
begin
	if NOT Odd(addr) & isValid_Addr(addr) then begin
		is_UPP := (pinteger(addr)^ = _MixedModeMagic);
		if is_UPP then begin
			wrt_str('RoutineDescriptor@');  wrt_Thex(addr);
			if UniversalProcPtr(addr)^.routineCount = 0 then
				with UniversalProcPtr(addr)^.routineRecords[0] do begin
					addr := ORD(procDescr);
					if ISA = ORD(kPowerPCISA) then addr := ORD(pTVec(addr)^.CodeAddr);
				wrt_str(' > ');  wrt_Thex(addr);
			end;
		end
		else begin
			cond_wrt_opt_space;
			if is_PPC then wrt_chr('p') else wrt_chr('c');
			Lst_Ptr( Clean_Addr(addr) )
		end;
{$IFC NOT isNosy}
		sav_doc := cur_doc;  in_ListProc := in_ListProc + 1;
		if pPtrtoPrel(addr) then begin 
			wrt_str(' =');  ListTask(cur_doc);  wrt_chr('.');  wrt_nameP;
		end;
		in_ListProc := in_ListProc - 1;
		UseDoc(sav_doc);
{$ENDC}
	end
	else wrt_Bad_Ptr(addr);
end;

PROCEDURE wrt_RefNum(RefNum:integer);
VAR name:strx;
begin
	wrt_chr('$');  wrt_hex(RefNum,4);
	if get_fName(@name,RefNum) then begin
		wrt_str(' -> ');
		if Length(name) = 0 then name := '"NO Name"';
		wrt_str(name)
	end
end;

{$IFC NOT isNosy}
PROCEDURE wrt_className(classID:integer);
VAR ts:strx;
begin
	wrt_chr(' ');  GetClassNameFromID(classID,ts);  wrt_str(ts);
end;
{$ENDC}

PROCEDURE LstBasVal(VAR size:integer; basetyp:integer; addr:Longint);
CONST c_maxChar = 60;
TYPE pExt = ^Extended;
		pREAL = ^Extended;  pDouble = ^Extended; { Kludges,  compiler calls _Pack4 }
VAR i,cix,typIw,fc:integer;  ch:CHAR;  DTR:DateTimeRec;	Val,tp:Longint;
		ts:strx;  obj_addr:hPtr;  tb:Boolean;
LABEL 1,2,3;

	function XferStr(first,lim:integer; zeroCh:integer):integer;
	VAR i:integer;  pca:pcharary;  ch:CHAR;
	begin
{$IFC NOT isNosy}
	if LT32(addr , MD_L_SysCom) then addr := addr+ORD(SG);
{$ENDC}
		pca := pcharary(addr+first);
		i := 0;  ts := '"';
		while (ORD(pca^[i]) <> zeroCh) and (i <= lim) do begin
			ch := pca^[i];
			if (ch < ' ') OR (ch > Chr($D9)) OR (ch = Chr($7F)) then ch := '.';
			i := i + 1;  ts[i+1] := ch;
		end;
		i := i + 2;  ts[i] := '"';  ts[0] := Chr(i);  wrt_str(ts);
		XferStr := i - 1
	end;

begin
	basetyp := BAND(basetyp,c_MtypIndx); {clear isPtr bit}
	size := TypEnt(basetyp)^.size;
	if (basetyp > c_LastOddType) AND (basetyp < ORD(b_strN))
			AND Odd(addr) then ErrMsg(ec_OddAddr)
{$IFC NOT isNosy}
  else if NOT Valid_Addr(addr) then wrt_str(' ? ') {BAD ADDR}
{$ENDC}
	else begin
		Val := Data_at(hPtr(addr),size); {rtns sign ext Longint}

{$IFC NOT isNosy}		 { Look for an output field position for TypeOver }
		WITH gTO_info DO if TO_CharPos > 0 then
			if bufrec.indx + Length(wst) = TO_CharPos then begin
				TO_typIw	:= basetyp;
				TO_addr		:= addr;  TO_size	:= size;  TO_CharPos := 0;
			end;
{$ENDC}
		wrt_chr(opt_space); { a Leading opt-space - field is modifiable }
	
	1:if basetyp >= b_QstrN then begin	{ P or C String }
			{ Strings cannot be modified }
			Mark_Field_NO_Modify;
			size := basetyp - b_QstrN;
			fc := BytePtr(addr)^;
			if fc >= size-1 then begin { C String }
				2:fc := XferStr(0,min(c_maxChar,size),0);  exit(LstBasVal);
			end
			else begin
				if fc >= 32 then
					for i := 1 to fc do if BytePtr(addr+i)^ = 0 then GOTO 2;
				basetyp := ORD(b_strN);	{ set for Pascal Str }
			end
		end;

		CASE basetyp OF
		0:begin
			wrt_chr('$');  wrt_hex(Val,8);  wrt_chr(' ');  ErrMsg(ec_QType);
			end;
		1:begin
				if ORD(Val) <> 0 then wrt_str('TRUE ') else wrt_str('FALSE')
			end;
		2:begin											{Byte}
				wrt_chr('$');  wrt_hex(Val,2)
			end;
		3:begin											{SgnByte}
				if OnePer then wrt_int(Val,4) else wrt_int(Val,-1);
			end;
		4:begin											{ASCII}
				i := Length(wst);
				if (i> 1) & (wst[i-1] = '''') then begin {kludge for Array of ASCII}
					wst[i-1] := Chr(BAND(Val,$0FF));  wst[i] := ''''
				end
				else wrt_subrng(BAND(Val,$0FF),0,e_chr)
			end;
	ORD(b_strN)..ORD(b_strN)+256,
		5:begin											{String - Pascal}
				if Val < 0 then Val := 256 - Val; {Data_at sign extends the Byte Val}
				size := Val + 1;  i := XferStr(1,min(Val-1,c_maxChar),-1)
			end;
		6:begin											{Cstr - search for 0 byte }
				size := XferStr(0,c_maxChar,0) {returns truncated size}
			end;
		7:Lst_Ptr(Val);							{Ptr - checks, etc}
{$IFC isNosy}
		8:if NOT ZroPtr(Val) then begin	{ProcPtr}
				addr := Val;
				if romflag then adj_ROM_addr(Val)
				else if is_MacII AND (BSR(BXOR(Val,MD_ROMBase32),24) = 0) then Val := SRA(Val); {Truncate to 24 bits}
				i := find_proc(Val);
				if (i > 0) & (procs^[i].len >= 0) then begin  get_name(i); wrt_str(ss) end
				else List_Proc_Ptr(addr);
			end;
{$ELSEC}		{Debugger}
		8:if NOT ZroPtr(Val) then begin	{ProcPtr}
				if (NOT Odd(Val)) & isValid_Addr(Val) & (pinteger(Val)^ = c_JMPABS) then begin
					tp := hPtr(Val+2)^;
					if NOT Odd(tp) then begin  addr := Val+2;  Val := tp  end;
				end;
				List_Proc_Ptr(Val);
			end;
{$ENDC}
ORD(b_hdl_Ary),							   {Handle}
		9:if NOT ZroPtr(Val) then begin
				if VD_ValidPtr(Val) then begin
					if Val = 0 then wrt_str(' Empty Handle')
					else Lst_Ptr(Val)
				end
			end;
																{integer}
   10:if OnePer then begin
	 			wrt_int(Val,7);
				If NOT g_inArry AND BTST(Dbgr_flags,ORD(DF_Show_Alt_Fmt)) then begin
					wrt_str('   = $');  wrt_hex(Val,4);
				end;
			end
			else wrt_int(Val,-1);
   11:begin											{WORD}
	 			if OnePer then wrt_str(' $');  wrt_hex(Val,4)
			end;
															  {Longint}
   12:begin
				 if OnePer then begin
				 		if BTST(Dbgr_flags,ORD(DF_Hex_Base)) then GOTO 3;
						wrt_int(Val,11) 
					end
					else wrt_int(Val,-1);
			end;
   13:begin								    	{HLongint}
3:			wrt_chr('$');  wrt_hex(Val,8);
				if (Val > 0) AND (BSR(Val,24) > 31) then	{ 1st char is legal ASCII }
				if NOT g_inArry AND OnePer AND BTST(Dbgr_flags,ORD(DF_Show_Alt_Fmt)) then begin
					wrt_str('   = ''');
					for i := 1 to 4 do begin
						ch := char4(Val)[i];
						if (ch < ' ') OR (ch > Chr($D9)) then ch := '.';
						wrt_chr(ch);
					end;
					wrt_chr('''');
				end;
			end;
   14:with DTR do begin {convert to date}
				Mark_Field_NO_Modify;
				Secs2Date(Val,DTR);
				wrt_int(Month,-1); wrt_chr('/');  wrt_int(Day,-1);    wrt_chr('/');  wrt_int(Year,2);  wrt_chr(' ');
				wrt_int(Hour,2);  wrt_chr(':');  wrt_int(Minute,2); wrt_chr(':');  wrt_int(Second,2);
      end;

   15:begin											{CHAR - Pascal def is size = 2 }
				wrt_subrng(BAND(Val,$0FF),0,e_chr)
      end;
   16:begin											{OSErr}
				get_syms(BAND(Val,$00ffFFFF)+c_SyserCode,SysErr,FALSE,FALSE);
				wrt_int(Val,-1);  wrt_chr(' ');
				with xsymlist do if n > 0 then begin
				  wrt_Lstr(@sn[1],12);  expnd_comnt(ts,typIw,cix,SysErr);  wrt_str(ts)
				end
      end;
   17:begin wrt_int(Val,-1)  end; {SCSCerr}
	 18:begin											{RefNum}
				wrt_RefNum(Val)
			end;
	 19:begin												{VRefNum}
				wrt_chr('$');  wrt_hex(Val,4);     {---more needed here ------}
			end;
	 20:begin												{ProcOffset}
				Mark_Field_NO_Modify;
				wrt_chr('$');  wrt_hex(Val,4);
				Val := Val + gRecAddr;  addr := ORD(@Val);  basetyp := ORD(b_pptr);
				wrt_chr(' ');  GOTO 1
			end;
{$IFC isNosy}
	21..23:ErrMsg(ec_NotYet);
	 24:begin 											{TrapWord}
				wrt_chr('_');  get_rom_name(D_TrpNum(Val),ts);  wrt_str(ts)
			end;
{$ELSEC}
	 21:begin 											{Real}
				if has_SANE then begin  wrt_fpS( pREAL(addr)^ )  end;
			end;
	 22:begin 											{Double}
				if has_SANE then begin  wrt_fpD( pDouble(addr)^ )  end;
			end;
	 23:begin 											{Extended}
				if has_SANE then begin  wrt_fpr( pExt(addr)^ )  end;
			end;
	 24:begin 											{TrapWord}
				wrt_chr('_');  get_rom_name(D_TrpNum(Val),ts);  wrt_str(ts)
			end;
	 25:begin 											{Qstr}
			end;
	 26:begin 											{Extend10}
				if has_SANE then begin  wrt_fpr10( pExt(addr)^ )  end;
			end;
	 27:begin 											{Fixed}
				if has_SANE then begin  wrt_Fixed( Val )  end;
			end;
  28:begin 											{ JT_Off - for MacApp }
				Mark_Field_NO_Modify;
				wrt_chr('$');  wrt_hex(Val,4);  wrt_chr(' ');
				get_name(fnd_blknum(JTOff_TO_SRA(Val)));  wrt_str(ss);
			end;
	29:begin 											{ ClassID - for MacApp }
				wrt_chr(' ');  wrt_int(Val,4);
				if (Val <> 0) & (pMA_Info <> 0) then wrt_className(Val);
			end;
	30:if pMA_Info <> 0 then begin	{ TObject - for MacApp }
				if Val = 0 then wrt_str(' NIL')
				else if Val = -1 then wrt_str(' deleted Object')
				else begin
					if is_Ptr_MacApp then tb := isValid_Addr(Val) & NOT Odd(Val)
													 else tb := ValidHdl(Val,obj_addr);
					if tb then begin
						wrt_class_At(Val);
					{	wrt_className(ClassID_Of(Val));  wrt_str('_@');  wrt_Thex(Val); }
					end
					else wrt_str(' Invalid Handle');
				end;
			end;
{$ENDC}
		end; {CASE}
	end;
end;

PROCEDURE lst_Str(typIw:integer; addr:Longint); {list String of Record #i }
VAR i,j,k,kk,m,lim,jsiz:integer;  pfld:pT_Typent;

	PROCEDURE nxt_fld;
	begin
		j := 4 + BAND($fffe,Length(pfld^.rname)+2);	i := i + j;  pfld := pointer(ORD(pfld)+j)
	end;

begin
	if BTST(typIw,c_isUsrT) then exit(lst_Str);
	if sym_typOF(typIw) <> rec then exit(lst_Str);
	get_RecLims(pfld,lim,typIw);
	i := 0;
	nxt_fld;
	while i < lim do with pfld^ do begin
		if f_off >= 0 then begin
			for k := 1 to 3 do if f_typ = strTyp[k] then begin
				addr := addr + f_off;  kk := k;
				while kk > 1 do begin
					if ZroPtr(addr) | NOT VD_ValidPtr(addr) then exit(lst_Str);
					addr := Clean_Addr(addr);  kk := kk - 1
				end;
				wrt_chr(' ');  m := Length(wst);  LstBasVal(jsiz,ORD(b_strx),addr);
				wst[m+1] := ' '; { remove the option-space }
				exit(lst_Str);
			end;
		end;
		nxt_fld
	end
end;

VAR rec_typIw:integer;

PROCEDURE RecAt(typIw:integer; addr:Longint);
VAR ts:strx;
begin
	typToStr(typIw,ts);  wrt_str(ts);
	wrt_str('_@');  wrt_Thex(addr);
	{ list string if not chain follower }
	if integer(BAND(m_NotisPtr,typIw)) <> rec_typIw then lst_Str(typIw,addr)
end;

PROCEDURE Record_AT(typIw:integer; addr:Longint);
begin
	rec_typIw := 0;  RecAt(typIw,addr)
end;

PROCEDURE Val_arry(VAR size:integer; typIw:integer; addr:Longint );
VAR i,aet,ll,ul,aetiW,jsiz,siz:integer;  par:pT_Typent;  eletype:T_eletype; ts:strx;
begin
	par := TypEnt(typIw);  GetBounds(par^.bndti,ll,ul,eletype);
	if eletype = e_unknown then exit(Val_arry);

	aetiW := par^.aeti; aet := ORD(sym_typOF(aetiW));
	if aet > ORD(equiv) then begin
		typToStr(aetiW,ts);  wrt_str(ts);  dump_WLine;
		for i := ll to ul do begin
			wrt_str('  [');  wrt_int(i,3);  wrt_str('] = ');
			Val_Of(siz,aetiW,addr);	addr := addr + siz;  chk_Wline(99);
			if chk_user then LEAVE;
		end;
	end
	else begin
		siz := PsizeOf(aetiW);
		if (siz > 1) and Odd(addr) then begin
			ErrMsg(ec_OddWAA); wrt_com;  addr := addr + 1
		end;
		if aetiW = ORD(b_strx) then siz := SizeOf(strx); { Pascal string, siz = 0 }
		jsiz := siz;
		for i := ll to ul do begin
			if chk_user then LEAVE;
			chk_Wline(6+jsiz);
			if aetiW <> ORD(b_ASCII) then wrt_chr(' ');
			g_inArry := TRUE;
			Val_Of(jsiz,aetiW,addr);  addr := addr + siz;
			g_inArry := FALSE;
		end;
	end;
  size := (ul+1-ll)*siz
end;

PROCEDURE Val_Set(VAR size:integer; typIw:integer; addr:Longint );
TYPE T_set = ARRAY[0..99] of integer;  pT_set = ^T_set;
VAR i,j,ll,ul,wds,bitNr,fBit:integer;  pSet:pT_set;  setVal:Longint;
		sepc:CHAR;  eletype:T_eletype;  SmallSet:Boolean;
LABEL 1;

	PROCEDURE lst_range; {from fBit to bitNr-1}
	begin
		if fBit >= 0 then begin
			chk_Wline(4);	wrt_chr(sepc);  wrt_subrng(fBit,typIw,eletype);
			if fBit < bitNr-1 then
					begin  wrt_str('..');  wrt_subrng(bitNr-1,typIw,eletype)  end;
		  sepc := ',';  fBit := -1
		end
	end;

begin
  typIw := TypEnt(typIw)^.eltyp; {the underlying SET type}
	GetBounds(typIw, ll,ul, eletype);
  if eletype = e_unknown then exit(Val_Set);
{$IFC NOT isNosy}
	if LT32(addr , MD_L_SysCom) then addr := addr+ORD(SG);
{$ENDC}
	pSet := pT_set(addr);  wds := BSR(ul+15 - ll,4) {DIV 16};  size := 2*wds;
	SmallSet := (ul+1 - ll <= 8);

  for i := 1 to wds-1 do if pSet^[i] <> -1 then GOTO 1;
  setVal := BSL(1,BAND(ul,15)+1) - 1;

  if BAND(setVal,pSet^[0]) = setVal then begin
    wrt_str('[-All-]');  exit(Val_Set)
  end;
1:sepc := '[';  bitNr := 0;  fBit := -1;
  for i := wds-1 downto 0 do begin
    setVal := pSet^[i];
		if SmallSet AND NOT Odd(addr) then setVal := BSR(setVal,8); { value is in upper byte }
    for j := 0 to 15 do begin
			if BTST(setVal,j) then begin if fBit < 0 then fBit := bitNr  end
			else lst_range;
     	bitNr := bitNr + 1;	if bitNr > ul then LEAVE;
    end
  end;
	lst_range;  if sepc = '[' then wrt_str('[]') else wrt_chr(']')
end;

PROCEDURE Get_CaseVar(pfld:pT_Typent; VAR caseVal:integer);
begin
  caseVal := gCaseVal;  gCaseVal := 0; {set externally}
{Look in some magic table to see if a specific variant is specified for this named record}
end;

PROCEDURE Lst_RecVal(VAR size:integer; typIw:integer; addr:Longint; isSOM:Boolean);
VAR k,lim,sav_gRec_typIw:integer;  sav_gRecAddr:Longint;  pfld,prec:pT_Typent;

  PROCEDURE List_Rec(indnt:integer);
  VAR CaseFound,CaseListed,fList,Vname:Boolean;  dataAddr,packData,Hdl_addr:Longint;
			i,nby,msb,lsb,caseVal,caseTyp,zsize,typIw,save_doc,fld_size,nbits :integer;  
			LC_rname:strx;  ii,jj,kk,n_som,som_typIw,som_Doc:integer;  SOM_REC:T_SOM_REC;
	LABEL 1;

		PROCEDURE nxt_fld;
		begin
			i := i + 4 + BAND($0fffe,Length(pfld^.rname)+2); pfld := pointer(ORD(prec)+i)
		end;

  begin
		Vname := OnePer;  fList := TRUE;
    CaseFound := FALSE;  CaseListed := FALSE;
		Get_CaseVar(pfld,caseVal);  caseTyp := 0; { I/O PB blocks/No case Sel }
	  i := 0;  msb := -1;
		REPEAT
			nxt_fld;  if i >= lim then LEAVE;
      WITH pfld^ do begin
				typIw := BAND(f_typ,m_NotIsCaseSel); { remove isPtr/isCaseSelect bit }
				k := f_off;
				if k < 0 then begin { Case Variant OR packed field Info }
					if BTST(k,14) then begin
						if CaseFound then begin if CaseListed then exit(List_Rec) end
						else begin
							CaseFound := (-k-2 = caseVal) 
													AND ((caseTyp = 0) OR (caseTyp = typIw));
							fList := CaseFound
						end
					end
					else begin  lsb := BAND($3fff,f_off);  msb := f_typ  end
				end
				else if fList then begin { field name & value }
				  CaseListed := CaseFound;
					copyStr(@LC_rname,Addr_TypNam(rname)^);
					{ skip "fillern' names}
					if (Length(LC_rname) >= 6) AND (LC_rname[1] = 'f')
						 AND (hPtr(@LC_rname[2])^ = $696C6C65) {'ille'} then CYCLE;
					
					{ Check for anonymous SOM Object type, MetroWerks only }
{$IFC NOT isNosy}
					if typIw = 0 then
					if On_PowerPC then
					if POS('$SOM', LC_rname) = 1 then with SOM_REC do begin
						{ Get the SOM internal type name }
						obj_addr := addr+k;
						if DO_SOM_info(SOM_REC) then begin
							save_doc := cur_doc;
							som_Doc := g_som_Doc;
							sort(@SOM_Info,n_som);
							wrt_str(' is a SOMObject');
							for ii := 1 to n_som do with SOM_Info[ii] do begin
								dump_WLine;
								jj := 0;  kk := 0;
								while SOM_cName^[kk] <> CHR(0) do begin
									jj := jj + 1;  wst[jj] := SOM_cName^[kk];  kk := kk + 1;
								end;
								wst[0] := CHR(jj);
								wrt_str('Data');
								copyStr(@LC_rname,wst);  wst := '';
								if get_SOM_Type(@LC_rname,som_Doc,som_typIw) then begin
									g_alt_doc := som_Doc;
									Lst_RecVal(kk, som_typIw, obj_addr+SOM_Off,TRUE);
								end
								else begin
									wrt_int(SOM_Off,-5);  wrt_chr(' ');
									wrt_str(LC_rname);  wrt_str('_@');  wrt_Thex(obj_addr+SOM_Off);
									if SOM_Len = 4 then begin
										wrt_str(' = ');  wrt_Hex(hPtr(obj_addr+SOM_Off)^,-8);
									end;
								end;
							end;
							UseDoc(save_doc);
							g_som_Doc := som_Doc;
							GOTO 1;
						end
						else begin	{ unknown SOM type }
							wrt_str('unknown SOM type');  GOTO 1;
						end;
					end;
{$ENDC}
				  if Vname then begin
						chk_Wline(20);
						wrt_int(k,5);  wrt_chr(' ');  wrt_Lstr(@LC_rname,19-indnt);
						wrt_chr(':') 
					end
					else chk_Wline(6);
					if msb >= 0 then begin	{ packed field, fb = msb }
						if BTST(Dbgr_flags,ORD(DF_BITFLD_SEX)) then begin
							nby := BSR(msb + 8,3); {DIV 8}	{ bits are numbered n downto 0 }
							packData := BAND( BSR( Data_at(hPtr(addr+k),nby) , lsb)
							, BSL(1,msb+1-lsb) - 1 ); {mask = 2**N - 1 }
						end
						else begin { bits are 0 to n - Aldus & 3.1d7 compiler}
							nbits := lsb + 1 - msb;
							packData := BAND( BROTL(BSL(Data_at(hPtr(addr+k),4),msb),nbits) 
												, BSL(1,nbits)-1 );  {mask = 2**N - 1 }
							nby := BSR(nbits + 7,3);  {DIV 8}
						end;
						fld_size := PsizeOf(typIw);
						if (fld_size = 4) AND (nby <= 2) then begin
							typIw := ORD(b_Word);  fld_size := 2;
						end;
						dataAddr := ORD(@packData) + 4 - fld_size;
					end
					else dataAddr := addr + k;
					Val_Of(zsize, typIw, dataAddr);
	1:			if OnePer then dump_WLine;
{$IFC NOT isNosy}
					if typIw = ORD(b_hdl_Ary) then begin	{ KLUDGE for Handle Array }
						nxt_fld;
						if ValidHdl(dataAddr,Hdl_addr) & (Hdl_addr <> 0) then with W_out do begin
							indent := indent + 2;
							wrt_str('  ');
							Val_Of(zsize, pfld^.f_typ, hPtr(Hdl_addr)^ );
							indent := indent - 2;
							if OnePer then dump_WLine;
						end;
					end
					else
{$ENDC}
				  if BTST(f_typ,c_IsCaseSel) then begin
						caseTyp := typIw;  fList := FALSE;  CaseFound := FALSE;
						if msb >= 0 then caseVal := packData
						else caseVal := Data_at(hPtr(dataAddr),zsize);
					end;
					msb := -1
				end
			end {WITH}
    UNTIL FALSE;
		if size < 0 then size := k + zsize; { SADE Array[xx] OF Anon RECORD }
  end;

begin {Lst_RecVal}
  if Odd(addr) then begin
		RecAt(typIw,addr);  ErrMsg(ec_OddAddr); exit(Lst_RecVal)
	end;
		{ kludge for grafPort -> CGrafPort & New TE Stuff }
	if typIw = typ_kludge[1] then begin
{		if BSR(GrafPtr(addr)^.portBits.rowBytes,14) = 3 then typIw := typ_kludge[2] }
		if BSR(pinteger(addr+6)^,14) = 3 then typIw := typ_kludge[2]
	end
	else if typIw = typ_kludge[3] then begin
{		if TEPtr(addr)^.txSize = -1 then typIw := typ_kludge[4] }
		if pinteger(addr+80)^  = -1 then typIw := typ_kludge[4]
	end;

	sav_gRecAddr := gRecAddr;  sav_gRec_typIw := gRec_typIw;
	gRecAddr := addr;  gRec_typIw := typIw;
	get_RecLims(prec,lim,typIw);
  pfld := prec;
	size := pfld^.f_typ;
  OnePer := isSOM OR (size > 8) OR (pfld^.f_off = -2); {Point & Rect on a line, -2 = C Union }
	if BTST(typIw,c_isUsrT) AND (size < 0) then OnePer := TRUE; { rec with VAR UB }
  if rec_typIw <> 0 then begin
    if NOT isSOM AND (size > 20) then begin
			wrt_chr(' ');  RecAt(typIw,addr);
		end
		else if OnePer then with W_out do begin
			wrt_str(Addr_TypNam(prec^.rname)^);  indent := indent + 2;	dump_WLine;
			List_Rec(2);  indent := indent - 2;  wst[0] := Chr(indent)
		end
		else List_Rec(0);
		dump_WLine;  OnePer := TRUE
	end
	else begin
		if OnePer then wrt_com;
		rec_typIw := typIw;  List_Rec(0);  rec_typIw := 0;  OnePer := gOnePer
	end;
	gRecAddr := sav_gRecAddr;  gRec_typIw := sav_gRec_typIw;
end;

PROCEDURE Val_Of(VAR size:integer; typIw:integer; addr:Longint);
VAR ts,tss:strx;  wi,obj_typIw,cv,ind,i,ll,ul,sv_typIw,classID:integer;
		eletype:T_eletype;  ptyp:pT_Typent;  sv_addr:Longint;  tps,ps:Pstrx;
		ptyp_1:pT_Typent;  last_typ:sym_typ;  hasLC,has_Pastype:Boolean;
LABEL 1,2,3;
CONST c_decl_types = (ORD(b_Byte)*$1000000)+(ORD(b_int)*$10000)+ORD(b_HLong);

{$IFC NOT isNosy}
	PROCEDURE TO_output_chk(size:integer);
	begin
		WITH gTO_info DO if TO_CharPos > 0 then
			if bufrec.indx + Length(wst) = TO_CharPos then begin
				TO_typIw	:= typIw;
				TO_addr		:= addr;
				TO_size		:= size;
				TO_CharPos := 0;
			end;
	end;
{$ENDC}								

begin
1:CASE sym_typOF(typIw) OF
		base:LstBasVal(size,typIw,addr);
	 equiv: begin
						ind := 0;  sv_typIw := typIw;  sv_addr := addr;
						ptyp_1 := TypEnt(typIw); { save name of 1st type }
						REPEAT
							ptyp := TypEnt(typIw);
							if ptyp = NIL then LEAVE; { bad in type info - C++ }
							typIw := ptyp^.eindx;
							if BTST(typIw,c_isPtr) then ind := ind + 1;
							last_typ := sym_typOF(typIw);
						UNTIL last_typ <> equiv;
						if ind = 0 then GOTO 1;
{$IFC NOT isNosy}
						TO_output_chk(4);		{	Look for an output field position for TypeOver }
{$ENDC}								
						wrt_chr(opt_space); { a Leading opt-space - field is modifiable }
						i := ind;  ts := '^^^';  ts[0] := Chr(ind);
						if ZroPtr(addr) then GOTO 3;
						REPEAT
							if NOT VD_ValidPtr(addr) | ZroPtr(addr) then GOTO 3;
							addr := Clean_Addr(addr); {remove bits in Master Ptr wd}
							i := i - 1
						UNTIL (i = 0) | NOT isRAMaddr(addr); {fini if pts to ROM}
	{$IFC NOT isNosy}
						{  NEED this check because of the extra DERef involved }
						if NOT Valid_Addr(addr) then begin
							wrt_Bad_Ptr(addr);  exit(Val_Of)
						end;
						{ KLUDGE to see if C++ type info needs an extra deref }
						if (ind = 1) & (ptyp_1^.ename = '?') & is_CaseSen
								& (last_typ = rec) then begin
						{ type is '^Tx' - ensure it is LowerCase }
							ptyp := TypEnt(typIw);  ps := pointer(ORD(ptyp)+TT_lead);
							tps := Addr_TypNam(ps^);
							hasLC := FALSE;
							for i := Length(tps^) downto 2 do begin
								if (tps^[i] >= 'a') AND (tps^[i] <= 'z') then begin
									hasLC := TRUE;  LEAVE;
								end;
							end;
							{ see if doing an extra DeRef yields a ptr to a Handle block }
							if hasLC & isMasterPtr_addr( hPtr(sv_addr)^ ) then begin
								{ option-space before carets for typeover }
								addr := hPtr(addr)^;  ts := '^^';  ind := 2;
							end;
						end;
	{$ENDC}
						if ind = 2 then begin
							ptyp := TypEnt(typIw); { pts to Record Entry }
							if Pstrx(ORD(ptyp)+TT_lead)^[1] = '?' then begin
	{$IFC NOT isNosy}
								{ Handle to Anon record - MacAPP, etc }
								if pMA_Info <> 0 then begin { substitute execution time type }
										if is_MA3_FAR then classID := hPtr(addr)^
																	else classID := pinteger(addr)^;
									GetClassNameFromID(classID,ts);
									if (Pos(' ',ts) = 0) & TnamToTypIw(ts,obj_typIw) & (obj_typIw <> sv_typIw) then begin
										if obj_typIw = ORD(b_CppKludge) then GOTO 2;
										sv_typIw := obj_typIw;
										if gRecAddr = 0 then begin
											typIw := TypEnt(TypEnt(obj_typIw)^.eindx)^.eindx;
											GOTO 1;
										end;
									end;
								end;
	{$ENDC}
								if gRecAddr = 0 then GOTO 1 { expand it }
								else begin
									typToStr(sv_typIw,ts);
								2:wrt_str(ts);  wrt_chr('@');  wrt_Thex( hPtr(sv_addr)^ );
									wrt_chr(' ');
									GOTO 3;	{ hPtr(sv_addr)^ - corresponding Kludge in StructureOf }
								end;
	{$IFC NOT isNosy}
							end	{ = '?' }
							else if BTST(Dbgr_flags,ORD(DF_CPLUS)) & BTST(typIw,c_isUsrT) then begin
								{ substitute execution time type }
								if (pMA_Info <> 0) & (has_vptr_field(typIw) = 0) then begin
									if is_MA3_FAR then classID := hPtr(addr)^
																else classID := pinteger(addr)^;
									GetClassNameFromID(classID,tss);
									if (Pos(' ',tss) = 0) & ci_TnamToTypIw(tss,obj_typIw) & (obj_typIw <> sv_typIw) then begin
										typIw := obj_typIw;
										ptyp := TypEnt(typIw); { if Pascal Object => ObjName@sv_addr }
										if tss = Addr_TypNam(Pstrx(ORD(ptyp)+TT_lead)^)^ then begin
												{ typeName = Pascal Class Name }
											ind := 0;  ts := ' ';  addr := hPtr(sv_addr)^;
										end;
									end;
								end;
	{$ENDC}
							end;
						end;
						If ORD(sym_typOF(typIw)) <> 0 then begin	{^^recname_@aaaaaa }
							chk_Wline(15);  wrt_str(ts);  RecAt(typIw,addr)
						end
						else begin	
							{ Option-space for typeover }
							if wst[Length(wst)] <> opt_space then wrt_chr(opt_space);
							wrt_chr('@'); wrt_Thex(addr);  wrt_str(' =');  Val_Of(i,typIw,addr);
							
							{ KLUDGE - Remove the option space from the data string }
							wi := Length(wst);
							while (wi > 0) AND (wst[wi] <> opt_space) do wi := wi - 1;
							if wst[wi] = opt_space then wst[wi] := ' ';
							
							{ KLUDGE to display 1st 9 chars of a C String }
							if is_CaseSen AND (typIw = m_isPtr+ORD(b_sgnbyte)) then begin
								if BytePtr(addr)^ <> 0 then Val_Of(i,b_QstrN+9,addr) { display C-Str }
							end;
						end;
					3:size := 4  {size of Ptr/Handle}
					end;
		decl: begin
						if (page_size > 0) AND BTST(typIw,c_isUsrT) then size := PsizeOf(typIw)
						else size := 2 - BAND(addr,1); {1 if Odd addr, size MAY BE byte }
						cv := Data_at(addr,size);
						if size = 1 then cv := BAND($0ff,cv); { get_aData sign extended it }
						get_decl_val(typIw,cv,ts);
						typIw := BAND( $03F, BROTL(
								(ORD(b_Byte)*$1000000)+(ORD(b_int)*$10000)+ORD(b_HLong),size*8));
{$IFC NOT isNosy}
						TO_output_chk(size);	{ check now so position isn't value dependent }
{$ENDC}								
						wrt_chr(opt_space);
						wrt_int(cv,-1);
						if Length(ts) > 0 then begin wrt_str('  ');  wrt_str(ts);  end;
					end;
	subrng:begin
						size := PsizeOf(typIw);
						GetBounds(typIw, ll,ul,eletype);
						cv := Data_at(addr,size);
						if (size = 1) AND (ll >= 0) then cv := BAND($0ff,cv); { get_aData sign extended it }
{$IFC NOT isNosy}
						TO_output_chk(size);
{$ENDC}								
						wrt_chr(opt_space);
						wrt_subrng(cv,typIw,eletype);
					end;
	arry:	Val_arry(size,typIw,addr);
	rec:	begin
{$IFC NOT isNosy}
					if (pMA_Info <> 0) & BTST(typIw,c_isUsrT) then begin
						{ substitute execution time type }
						if is_Ptr_MacApp & (has_vptr_field(typIw) = 2) then begin
							classID := pinteger(addr)^;		{ fClassID }
							GetClassNameFromID(classID,tss);
							if (Pos(' ',tss) = 0) & TnamToTypIw(tss,obj_typIw) then begin
								typIw := obj_typIw;
								{ so Txx = Tyy works }
								if sym_typOF(typIw) = equiv then typIw := pu_sym_typOF^.eindx;
							end;
						end;
					end;
{$ENDC}
					Lst_RecVal(size,typIw,addr,FALSE);
				end;
	set_:	Val_Set(size,typIw,addr);
	end; {case}
end;

PROCEDURE ValueOf(VAR size:integer; typIw:integer; addr:Longint; fOnePer:Boolean );
begin
	if addr <> 0 then begin
		rec_typIw := 0;  OnePer := fOnePer;  gOnePer := fOnePer;  gRecAddr := 0;
		Val_Of(size,typIw,addr)
	end
	else wrt_str(' <NIL_Address>');
end;

		{PsizeOf - return the size in bytes of a variable of type 'typIw' }

FUNCTION  PsizeOf( typIw:integer ):integer;
VAR ll,ul:integer;  p:pT_Typent;  eletype:T_eletype;
LABEL 1;
begin
1:IF BTST(typIw,c_isPtr) then PsizeOf := 4
	else
	CASE sym_typOF(typIw) OF
		base:if typIw < ORD(b_strN) then begin
							PsizeOf := TypEnt(typIw)^.size;
							if (typIw = ORD(b_ClassID)) & is_MA3_FAR then PsizeOf := 4;
						end
						else begin
							if typIw < b_QstrN then PsizeOf := typIw - ORD(b_strN)
							else PsizeOf := typIw - b_QstrN
						end;
	 equiv:begin typIw := TypEnt(typIw)^.eindx;  GOTO 1  end;
		decl:begin
					 ul := TypEnt(typIw)^.val;
					 if ul < 0 then PsizeOf := 4	{ set by SADE/sfc_Enum }
					 else PsizeOf := ORD(ul > 255) + 1
				 end;
	subrng:begin
					PsizeOf := 2;
					GetBounds(typIw, ll,ul,eletype);
					if (ul <= 127) AND (ll >= -255) AND (ul+1-ll <= 256) then PsizeOf := 1;
				end;
		arry:begin
					 p := TypEnt(typIw);  GetBounds(p^.bndti,ll,ul,eletype);
					 PsizeOf := PsizeOf(p^.aeti)*(ul+1-ll)
				 end;
		rec: begin
						get_RecLims(p,ul,typIw);	PsizeOf := p^.f_typ;
					end;
		set_:begin
					typIw := TypEnt(typIw)^.eltyp; {the underlying SET type}
					GetBounds(typIw, ll,ul, eletype);
					PsizeOf := 2 * BSR(ul+15 - ll,4) {DIV 16};
				end;
			{ otherwise -Writeln('PsizeOf ERROR - bad type table word passed'); }
	end
end;

{$S list_data} {KLUDGE, ran out of space in disasm}

PROCEDURE TrapListInfo(VAR s:strx; VAR TypErr:integer);
VAR 
	A:ARRAY[1..c_TrMaxParams] OF T_paramInfo;  typeStr:strx;
	i,j,size,lowParam, hiParam,paramSize:integer;  typIw:T_typIndx; 
	isVar,isReg,is_Ptr,MPW_C:Boolean;  paramP,pAj:pT_paramInfo;

	PROCEDURE GetVarStr(ds:Pstrx);
	VAR j:integer;
	begin
		j := 0;
		WHILE NOT (s[i] IN [',', ':']) do begin
			j := j + 1; ds^[j] := s[i]; i := i + 1
		end;
		{ WHILE ds^[j] = ' ' DO j := j - 1; {eliminate any blanks}
		ds^[0] := Chr(j)
	end;
	
	PROCEDURE GetTypeStr(VAR s:strx; VAR i:integer);
	VAR j:integer;
	begin
		j := 0;
		WHILE NOT (s[i] IN [';', ')' ,'{', '}']) DO begin
			j := j + 1; typeStr[j] := s[i]; i := i + 1
		end;
		{ WHILE ds^[j] = ' ' DO j := j - 1; {eliminate any blanks}
		typeStr[0] := Chr(j);
	(* MUST DO THE FOLLOWING BETTER, SOMEHOW, IF THIS IS USED INTERACTIVELY *)
		IF typeStr = 'Str255' THEN typeStr := 'String';
		IF NOT ci_TnamToTypIw(typeStr, typIw) THEN begin
			wst := ' unknown Type: ';  wrt_str(typeStr);  dump_WLine;
			typIw := 0;  TypErr := 1;
		end
	end;

	FUNCTION RegNum(VAR i:integer):integer;
	VAR j:integer;
	begin
		j := ORD(s[i+1]) - ORD('0');  IF s[i] = 'A' THEN j := j + 8;
		RegNum := j;  i := i + 3
	end;

begin {TrapListInfo}
	paramSize := 0;  TcAuxi.flags := 0;  paramP := @TrpBuf;
	lowParam := 1;  i := 0;  TypErr := 0;
	MPW_C := FALSE;
	if s[1] = '' then begin MPW_C := TRUE;  i := 1  end;
	if s[i+1] = '(' then begin
		i := i + 2;
		WHILE s[i] <> ')' DO begin
			hiParam := lowParam;
			isVar := ((s[i] = 'V') AND (s[i+1] = 'A') {AND (s[i+2] = 'R')} );
			IF isVar then begin
				i := i + 4;  TcAuxi.isVar := TRUE
			end;
			WHILE (s[i] <> ':') DO begin
				isReg := (s[i+2] IN ['|', '\', '/']);
				IF isReg THEN begin
					if s[i+2] IN ['|', '\'] then TcAuxi.isVar := TRUE;
					A[hiParam].offset := RegNum(i);
				end;
				GetVarStr(@A[hiParam].name);
				if (s[i] = ',') THEN begin hiParam := hiParam + 1;  i := i + 1  end;
			end;
			i := i + 1; { pass over the ':' }
			GetTypeStr(s, i);
			size := PsizeOf(typIw); {always use the FIRST type to determine size}
			IF s[i] = '{' THEN begin
				i := i + 2;   (* past the '{|' *)
				GetTypeStr(s, i);
				IF s[i] = '}' THEN i := i + 1;
			end;
			IF s[i] = ';' THEN begin i := i + 1; IF s[i] = ' ' THEN i := i + 1  end;

						{ size = # of bytes of thing on the stack: }
			is_Ptr := isVar OR (size = 0) OR (size > 4);
			IF is_Ptr OR (size > 2) OR MPW_C THEN size := 4 else size := 2;
			IF is_Ptr THEN begin 
				typIw := Bor(typIw, m_isPtr);  TcAuxi.SaveEnt := TRUE
			end;
			FOR j := lowParam TO hiParam do begin 
				A[j].typIndx := typIw;
					{ could only have a problem here if there is a comma separated
								list where one VAR is in a reg and another is not }
				IF NOT isReg THEN begin
					paramSize := paramSize + size;  A[j].offset := -paramSize 
				end;
			end;
			lowParam := hiParam + 1;
		END; {while}
	end;
	{ offsets are the Negative of the distance from the RTN addr to the param}
	lowParam := lowParam - 1;
	FOR j := 1 to lowParam DO begin
		pAj := @A[j];
		if pAj^.offset < 0 THEN pAj^.offset := -(paramSize + 4 + pAj^.offset);
		with paramP^ do begin
			offset := pAj^.offset;	typIndx := pAj^.typIndx;	copyStr(@name,pAj^.name);
		end;
		paramP := pointer(ORD(paramP)+4+BAND(Length(pAj^.name)+2,$0FFFE) )
	end;
	with TcAuxi do begin
		nParams := lowParam;  stkSize := paramSize;
		i := i + 2; {point past '):' }
		if i < Length(s) then begin {is a function}
			if MPW_C then funSize := 0 {D0}
			else begin
				s[Length(s)+1] := ';';
				if s[i+2] = '\' then begin funSize := RegNum(i);  GetTypeStr(s,i)	end
				else begin
					GetTypeStr(s,i);  funSize := -PsizeOf(typIw)
				end;
				isFunc := TRUE;  funType := typIw
			end
		end
	end
end;


PROCEDURE Get_TrapInfo(trpNum:integer; VAR s:strx);
VAR errs:integer;
begin
	if Length(s) > 0 then TrapListInfo(s,errs)
	else with TcAuxi do begin
		nParams := 0;  stkSize := 0;  funType := 0;  funSize := 0;  flags := 0
	end
end;

(*
PROCEDURE maktbl; {kludge into S command in Nosy TTY mode}
VAR i,j,k:integer; ns,s:strx;
begin
	for i := 0 to 1024+256 do with TcAuxi do begin
		get_rom_name(i,ns);
		trap_list(i,s);
		Get_TrapInfo(i,s); {results in TcAuxi & TrpBuf }
		k := BSL(ORD(isVar),7)+BSL(ORD(isFunc),6)+BSL(ORD(SaveEnt),5);
		j := 1;  if stkSize > 9 then j := 2;
		write(c_Tab,'TrapI',c_Tab,k:3,',',stkSize:j);

		if Pos('IOPB:',s) > 0 then write(',c_IO')
		else if Pos('EventRecord',s) > 0 then write(',c_Evnt')
		else write(',0');

		writeln(c_Tab,c_Tab,'; ',ns)
	end
end;
*)

end. {Val_Dbg}
